/*
 * StringTest.java
 *
 * version: 26th October 2008, 20:33
 * author: yanas
 */
package cz.yanas.pb162.strings;

/**
 * Demonstrates the difference between the String and the StringBuilder classes.
 *
 * @author yanas
 */
public final class Main {

    /**
     * Performs the comparison of the String class with the StringBuilder class.
     *
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // save the current time so we can use it later to compute the execution time
        long time = System.currentTimeMillis();

        // start with an empty string
        String string = "";

        // perform 10 000 iterations -- that should be enough to take some time
        for (int i = 0; i < 10000; i++) {
            // this operation takes a lot of time!
            string += Integer.toString(i);
        }

        // print the results, mainly including the execution time
        System.out.println(System.currentTimeMillis() - time);
        System.out.println(string);

        // save the current time so we can use it later to compute the execution time
        time = System.currentTimeMillis();

        StringBuilder stringBuilder = new StringBuilder();

        // perform 10 times more iterations to stress that StringBuilder rocks!
        for (int i = 0; i < 100000; i++) {
            // this operation is much better!
            stringBuilder.append(Integer.toString(i));
        }

        // print the results, focus on the execution time
        System.out.println(System.currentTimeMillis() - time);
        System.out.println(stringBuilder);
    }

    private Main() {
    }

}
